package dense.randGAME.Entity;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.geom.Rectangle;

import dense.randGAME.Level.Level;

public abstract class Entity { //Base entity class
	protected Level level;
	
	protected float x, y;
	protected float width, height;
	
	protected String type;
	
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public Entity(Level level, float x, float y, float width, float height, String type){
		this.level = level;
		this.x = x;
		this.y = y;
		this.width = width;
		this.height = height;
		this.type = type;
	}
	
	// This have to be @override //
	public abstract void update(int delta);		 // Update entity
	public abstract void render(Graphics g);	 // Render entity
	public abstract void collided(Entity other); // When collision occurs
	
	// Get collision rectangle //
	public Rectangle getRect(){
		return new Rectangle(x, y, width, height);
	}
	
	public float getX() {
		return x;
	}

	public void setX(float x) {
		this.x = x;
	}

	public float getY() {
		return y;
	}

	public void setY(float y) {
		this.y = y;
	}
}
