package dense.randGAME;

import javax.swing.JComboBox.KeySelectionManager;

import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;

import dense.randGAME.Level.Level;
import dense.randGAME.Level.Tree;
import dense.randGAME.levelgen.LevelGen;

public class GameState extends BasicGameState{
	public static final int ID = 0;
	
	public static final int MWIDTH = 128;
	public static final int MHEIGHT = 128;
	
	private Level level;
	
	public GameState(){
		
	}

	@Override
	public void init(GameContainer gc, StateBasedGame sbg)
			throws SlickException {
		level = new Level(new LevelGen().GenerateMap(MWIDTH, MHEIGHT));
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g)
			throws SlickException {
		g.scale(2, 2);
		level.render(g);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int delta)
			throws SlickException {
		if(gc.getInput().isKeyDown(Input.KEY_UP)){
			level.player.setY(level.player.getY() - 0.2f * delta);
		}
		if(gc.getInput().isKeyDown(Input.KEY_DOWN)){
			level.player.setY(level.player.getY() + 0.2f * delta);		
		}
		if(gc.getInput().isKeyDown(Input.KEY_LEFT)){
			level.player.setX(level.player.getX() - 0.2f * delta);
		}
		if(gc.getInput().isKeyDown(Input.KEY_RIGHT)){
			level.player.setX(level.player.getX() + 0.2f * delta);
		}
		if(gc.getInput().isKeyPressed(Input.KEY_G)){
			level = new Level(new LevelGen().GenerateMap(MWIDTH, MHEIGHT));
		}
		level.update(gc, delta);
	}

	@Override
	public int getID() {
		return ID;
	}

}
