package dense.randGAME.Level;

import java.util.Random;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;

import dense.randGAME.GameState;
import dense.randGAME.Entity.Camera;
import dense.randGAME.Entity.Entity;
import dense.randGAME.Entity.EntityManager;
import dense.randGAME.Entity.Player;

public class Level {
	private EntityManager em;
	public static Camera cam;
	public static Player player;
	
	public Level(){
		em = new EntityManager();
	}
	
	public Level(int[][] map){
		cam = new Camera(this, 0, 0, 320, 240);
		em = new EntityManager();
		em.AddEntity(new Tilemap(this, map));
		
		for(int i = 0; i < 500; i++){
			int randX, randY;
			randX = new Random().nextInt(map.length - 1);
			randY = new Random().nextInt(map[0].length - 1);
			if(map[randY][randX] == 1){
				add(new Tree(this, (randX * 16) - 4, (randY * 16) + 14));
				System.out.println("X: " + randX + " Y: " + randY);
			}
		}
		
		int randX, randY;
		while(true){
			randX = new Random().nextInt(map.length - 1);
			randY = new Random().nextInt(map[0].length - 1);
			if(map[randY][randX] != 2){
				randX *= 16;
				randY *= 16;
				if(randX > GameState.MWIDTH * 16) randX = GameState.MWIDTH * 16 - 16;
				if(randY > GameState.MHEIGHT * 16) randX = GameState.MHEIGHT * 16 - 16;
				if(randX < 0) randX = 0 + 16;
				if(randY < 0) randY = 0 + 16;
				break;
			}
		}
		
		player = new Player(this, randX, randY);
		em.AddEntity(player);
	}
	
	// Add entities to level :TODO//
	public void add(Entity e){
		em.AddEntity(e);
	}
	
	public void remove(Entity e){
		em.RemoveEntity(e);
	}

	public void update(GameContainer gc, int delta) {
		// TODO Auto-generated method stub
		em.checkCollision();
		em.updateAll(delta);
		cam.update(delta);
	}
	
	public void render(Graphics g){
		em.renderAll(g);
	}
}
