package dense.randGAME.levelgen;

import java.awt.Color;

import dense.randGAME.Level.Tile;

public class LevelGen {
	public static final int octaveCount = 5;
	public static final int waterDepth = 120;
	public static final int sandDepth = 90;
	
	public LevelGen(){
		
	}
	
	public int[][] GenerateMap(int width, int height){
		int[][] map = new int[width][height];
		
		float[][] wnoise = PerlinNoise.GenerateWhiteNoise(width, height);
		float[][] pnoise = PerlinNoise.GeneratePerlinNoise(wnoise, octaveCount);
		
		Color[][] mapG = PerlinNoise.MapGradient(Color.black, Color.white, pnoise);
		for(int i = 0; i < width; i++){
			for(int j = 0; j < height; j++){
				if(mapG[i][j].getRed() >= waterDepth && mapG[i][j].getBlue() >= waterDepth && mapG[i][j].getGreen() >= waterDepth){
					map[i][j] = Tile.WATER;
				}else if(mapG[i][j].getRed() < waterDepth && mapG[i][j].getBlue() < waterDepth && mapG[i][j].getGreen() < waterDepth
						&& mapG[i][j].getRed() > sandDepth && mapG[i][j].getBlue() > sandDepth && mapG[i][j].getGreen() > sandDepth){
					map[i][j] = Tile.SAND;
				}else{
					map[i][j] = Tile.GRASS;
				}
			}
		}
		
		return map;
	}
}
